<?php
/**
 * @author          jtotal <support@jtotal.org>
 * @link            https://jtotal.org
 * @copyright       Copyright © 2020 JTOTAL All Rights Reserved
 * @license         GNU GPLv3 <http://www.gnu.org/licenses/gpl.html> or later
*/

defined('JPATH_PLATFORM') or die;

class JFormFieldJTaccordion extends JFormField
{
    protected $type = 'jtaccordion';

	public function getLabel() {
		// code that returns HTML that will be shown as the label
		$initial = strtolower($this->element['initial']);
		$initial = '';
		return $initial;
	}

    protected function getInput()
    {

        $id = strtolower($this->element['id']);
        $mode = strtolower($this->element['mode']);

        $initial = strtolower($this->element['initial']);
        $label = strtolower($this->element['label']);
        $slide = strtolower($this->element['slide']);
        $acordeon = strtolower($this->element['acordeon']);

        $active = strtolower($this->element['active']);

        $jversion = new JVersion();


        //////////////
        //V4.X
        if(version_compare($jversion->getShortVersion(), '4.0', 'ge')){

            if($initial=='true'){
                return JHtml::_('bootstrap.startAccordion', $acordeon, array('active' => $active));

            }elseif($initial=='slide'){
                $slider = JHtml::_('bootstrap.addSlide', $acordeon, JText::_($label), $slide);
                return $slider;
                
            }elseif($initial=='end'){
                $end = JHtml::_('bootstrap.endSlide');
                return $end;

            }elseif($initial=='superend'){

                $superend = JHtml::_('bootstrap.endAccordion');
                return $superend;

            }

        ////
        //V3.X
        }elseif(version_compare($jversion->getShortVersion(), '3.0', 'ge')){

            if($initial=='true'){
                return JHtml::_('bootstrap.startAccordion', $acordeon, array('active' => $active));

            }elseif($initial=='slide'){
                $slider = JHtml::_('bootstrap.addSlide', $acordeon, JText::_($label), $slide);
                return $slider;
                
            }elseif($initial=='end'){
                $end = JHtml::_('bootstrap.endSlide');
                return $end;

            }elseif($initial=='superend'){

                $superend = JHtml::_('bootstrap.endAccordion');
                return $superend;

            }
        }


    }




}
