<?php
/**
 *
 * @copyright   Copyright (C) 2021 JTotal, Inc. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
*/

defined('JPATH_PLATFORM') or die;

use JTFramework\JTlicense;
use Joomla\CMS\Factory;
use Joomla\CMS\Filesystem\Folder;
use Joomla\CMS\Form\FormField;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Uri\Uri;

$jtfwAutoload = JPATH_PLUGINS . '/system/jtframework/autoload.php';
if (is_file($jtfwAutoload))
{
    require_once $jtfwAutoload;
}else{
    Factory::getApplication()->enqueueMessage(Text::_('JT_FW_NOT_FOUND'), 'error');
    return;
}

class JFormFieldJtClearCache extends FormField
{
    protected $type = 'jtclearcache';
    protected $directory;

    protected function getLabel(){
        //return "asdf";
    }

    protected function getInput()
    {
 
     
       
        $fV= '';
        $cache_path_abs = JPATH_SITE.'/cache/'.$this->element['directory'];

    
        $disabled = 'disabled';
        $countFiles = '0';
        if(Folder::exists($cache_path_abs)){
            $disabled = '';
            $countFiles = count(Folder::files($cache_path_abs));
        }else{
            return '';
        }
        $fV .= '<a class="btn btn-link btn-light  position-relative '.$disabled.'" id="jt_clearCache" onClick="JTClearCache()">'.Text::_('JT_CLEAR_CACHE').' 
        <span id="jt_clearCache_pill" class="position-absolute top-0 start-100 translate-middle badge rounded-pill bg-danger">
        '. $countFiles.'
        <span class="visually-hidden">files</span>
        </span></a>';



      $fV .= "<script>

        async function postData(url = '') {
            const response = await fetch(url, {
                method: 'POST',
                mode: 'cors',
                cache: 'no-cache', 
                credentials: 'same-origin', 
                headers: {
                  'Content-Type': 'application/json'
                }
              });
            return response.json();
        }

        function JTClearCache(){
            postData('".Uri::root()."index.php?option=com_ajax&group=system&plugin=JTFramework&task=ClearCache&directory=".$this->element['directory']."&format=json')
            .then(data => {
              console.log(data.data[0]); 
              if(data.data[0] === true){
                document.getElementById('jt_clearCache').classList.add('disabled');
                document.getElementById('jt_clearCache_pill').classList.add('hide');
                document.getElementById('jt_clearCache_pill').innerHTML = 0;
              }
            });
        }
 
        </script>";
       
        return $fV;
    }




}

