<?php

/**
 * @author          jtotal <support@jtotal.org>
 * @link            https://jtotal.org
 * @copyright       Copyright © 2020 JTOTAL All Rights Reserved
 * @license         GNU GPLv3 <http://www.gnu.org/licenses/gpl.html> or later
*/

defined('JPATH_PLATFORM') or die;

use JTFramework\JTlicense;
use JTFramework\JTdebug;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Factory;
use Joomla\CMS\Form\FormField;
use JTFramework\JTfunc;

if (is_file(JPATH_PLUGINS . '/system/jtframework/autoload.php'))
{
    require_once JPATH_PLUGINS . '/system/jtframework/autoload.php';
}else{
    $app = Factory::getApplication();
    $app->enqueueMessage(Text::_('JT_FW_NOT_FOUND'), 'error');
    return;
} 


class JFormFieldJtLicenseCheck extends FormField
{
    protected $type = 'jtlicensecheck';

    public $tiempo = '';
    public $error = array();

    protected function getLabel(){
        $mode = $this->element['mode'];
        if($mode == 'dashboard'){
            return;
        }
        //return "<strong>License</strong>";
    }

    protected function getInput()
    {
        
        $valida = JTlicense::_checkLicense();

        $field_value = '';
        if($valida){
            /*PRO*/
             $field_value .= $this->pro();
         }else{
            /*LITE*/
             $field_value .= $this->lite();
        }

        
        $validaBool = ($valida) ? 1 : 0; 
        $jsVar = 'const jtlicensecheck = '. $validaBool.';';
        if(JTfunc::isJ4()){
            $wa = Factory::getDocument()->getWebAssetManager();
            $wa->addInlineScript($jsVar);
        }else{
            $doc = $this->getDocument;
            Factory::getDocument()->addScriptDeclaration($jsVar);
        }

        $field_value .= JTdebug::showDebug();

        $field_value .= '<input type="hidden" id="'.$this->id.'" name="'.$this->name.'" value="'.$validaBool.'"/>';
  
        return $field_value;
    }




    private function lite(){
        return jtlicense::mensajeLITE();
    }


    private function pro(){
        return jtlicense::mensajePRO();
    }


}
