<?php
/**
 * @author          jtotal <support@jtotal.org>
 * @link            https://jtotal.org
 * @copyright       Copyright © 2020 JTOTAL All Rights Reserved
 * @license         GNU GPLv3 <http://www.gnu.org/licenses/gpl.html> or later
*/

defined('JPATH_PLATFORM') or die;

require_once  JPATH_PLUGINS . '/system/jtframework/autoload.php';

use JTFramework\JTfunc;
use JTFramework\JTdebug;
use Joomla\CMS\Form\FormHelper;
use Joomla\CMS\Factory;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Form\FormField;


/**
 * GET EXTENSION VERSION
 */
class JFormFieldJTversion extends FormField
{
    /**
     * The form field type.
     *
     * @var    string
     * @since  11.1
     */
    protected $type = 'jtversion';


	protected function getLabel(){

        $return='';
        if($this->element['logo'] && $this->element['logo'] !=''){
            $return .= '<img style="max-width:150px;" class="img-fluid img-responsive" src="'.$this->element['logo'].'" alt="'.$this->element['element'].'"/></br> ';
        }

        return $return;
    }


    /**
     * Get the db version
    */

	protected function getInput()
	{

        $element = $this->element['element'];

        if(!$element){
            return '<div class="alert alert-info">'
			. Text::_('JT_FW_ERROR_NOT_ELEMENT')
			. '</div>';
        }

		$db = Factory::getDbo();
		$result = null;
        $result = $db->setQuery(
            $db->getQuery(true)
            ->select($db->quoteName('manifest_cache'))
			->from($db->quoteName('#__extensions'))
			//->where($db->quoteName('folder') . ' = ' . $db->quote('actionlog'))
			->where($db->quoteName('element') . ' = ' . $db->quote($element))
        )->loadResult();

		try
		{
			$result = json_decode($result);
		}
		catch (RuntimeException $e)
		{
			JError::raiseWarning(500, $e->getMessage());
		}
        
        $return='';

        $return .= '<span class="badge badge-info"><i class="fas fa-code-branch"></i> Version: '.$result->version.' </span> ';
        $return .= '<span class="badge badge-deafult"><i class="fas fa-calendar-alt"></i> '.$result->creationDate.' </span> ';

        return $return;

        if(JTfunc::isJ4()){

        }else{

        }



	}



}
