<?php

/**
 * @author          jtotal <support@jtotal.org>
 * @link            https://jtotal.org
 * @copyright       Copyright © 2020 JTOTAL All Rights Reserved
 * @license         GNU GPLv3 <http://www.gnu.org/licenses/gpl.html> or later
 */

defined('_JEXEC') or die('Restricted access');

//jimport('joomla.filesystem.file');

use Joomla\CMS\Filesystem\Folder;
use Joomla\CMS\Log\Log;
use Joomla\CMS\Session\Session;
use Joomla\CMS\Language\Text;
use Joomla\CMS\Plugin\CMSPlugin;

// Initialize
//require_once __DIR__ . '/autoload.php';

class plgSystemJTFramework extends CMSPlugin
{
    /**
     *  Auto load plugin language
     *
     *  @var  boolean
     */
    protected $autoloadLanguage = true;

    /**
     *  The Joomla Application object
     *
     *  @var  object
     */
    protected $app;

    /**
     *  Plugin constructor
     *
     *  @param  mixed   &$subject
     *  @param  array   $config
     */
    public function __construct(&$subject, $config = array())
    {
        // Declare extension logger
        Log::addLogger(
            array('text_file' => 'plg_system_jtframework.php'),
            Log::ALL,
            array('jtframework')
        );

        // execute parent constructor
        parent::__construct($subject, $config);
    }

    public function onAfterInitialise()
    {
        //JLoader::registerPrefix('JTFramework', JPATH_PLUGINS . '/system/jtframework/JTFramework');
        //JLoader::registerNamespace('JTFramework', JPATH_PLUGINS . '/system/jtframework/JTFramework');
        //require_once __DIR__ . '/autoload.php';

    }


    public function onAjaxPluginParams()
    {
        Session::checkToken('request') or jexit(Text::_('JINVALID_TOKEN'));
        return json_encode("nook");
    }

    public function onAjaxJTFramework()
    {

        /* 		Session::checkToken('request') or jexit(Text::_('JINVALID_TOKEN'));

        // Only in backend
        if (!$this->app->isClient('administrator'))
        {
            return;
        } */

        // Check if we have a valid task
        $task = $this->app->input->get('task', null);

        // Check if we have a valid method task
        $taskMethod = 'ajaxTask' . $task;

        if (!method_exists($this, $taskMethod)) {
            die('Task not found');
        }

        return $this->$taskMethod();
    }

    /**
     * Clears cache
     *
     * @return void
     */
    private function ajaxTaskClearCache()
    {

        $directory = $this->app->input->get('directory', null);

        if (!$directory) return false;

        if (Folder::exists(JPATH_SITE . '/cache/' . $directory)) {
            return Folder::delete(JPATH_SITE . '/cache/' . $directory);
        } else {
            return '';
        }

        return '';
    }
}
